#include <stdio.h>
#include <math.h>
#include <string.h>
#include <mem.h>
#include <stdlib.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <vc.h>


point::point()
{
xyz=(char *)malloc(64);
val[3]=9999.9999;
r2=-1;
}

point::~point()
{
free(xyz);
}

void point::Init()
{
val[0]=0,val[1]=0,val[2]=0,val[3]=0;
}

VC::VC()
{
}

VC::~VC()
{
free(resultsBuff);
free(fileBuff);
}

int VC::Init()
{
int code=0,idx;
for(idx=0;idx<100;c2[idx].Init(),idxArray[idx]=-1,idxArray1[idx]=-1,
    idxArray2[idx++]=-1);
depCount=0,destCount=0;
resultsBuff=(char*)malloc(64*1024);
tempBuff=(char*)malloc(64*1024);
return code;
}

int VC::ValidateInput()
{
int code=1;
if(c1[1].val[0]==0||c1[1].val[1]==0||c1[1].val[2]==0)
   {
   printf("ZERO DELTA ENTRY DETECTED....\n");
   sprintf(tempBuff,"ZERO DELTA ENTRY DETECTED....\n");
   strcat(resultsBuff,tempBuff);
   if(c1[1].val[0]==0)
      {
      printf("ZERO X DELTA\n");
      sprintf(tempBuff,"ZERO X DELTA\n");
      strcat(resultsBuff,tempBuff);
      }
   if(c1[1].val[1]==0)
      {
      printf("ZERO Y DELTA\n");
      sprintf(tempBuff,"ZERO Y DELTA\n");
      strcat(resultsBuff,tempBuff);
      }
   if(c1[1].val[2]==0)
      {
      printf("ZERO Z DELTA\n");
      sprintf(tempBuff,"ZERO Z DELTA\n");
      strcat(resultsBuff,tempBuff);
  }
   printf("VC ATTEMPT WILL RESULT IN OVERFLOW...ABORTING...\n");
   sprintf(tempBuff,"VC ATTEMPT WILL RESULT IN OVERFLOW...ABORTING...\n");
   strcat(resultsBuff,tempBuff);
   code=0;
   }
return code;
}

void VC::SortMinMax()
{
int temp;
max.val[0]=MAX(c1[2].val[0],c1[3].val[0]);
min.val[0]=MIN(c1[2].val[0],c1[3].val[0]);
max.val[1]=MAX(c1[2].val[1],c1[3].val[1]);
min.val[1]=MIN(c1[2].val[1],c1[3].val[1]);
max.val[2]=MAX(c1[2].val[2],c1[3].val[2]);
min.val[2]=MIN(c1[2].val[2],c1[3].val[2]);
}

int VC::ColinearitySearch()
{
double colin,dist;
int xl,yl,zl,minx=400,miny=400,minz=0,maxx=560,maxy=560,maxz=100,count=0;
max.val[0]=MIN(max.val[0],maxx);
min.val[0]=MAX(min.val[0],minx);
max.val[1]=MIN(max.val[1],maxy);
min.val[1]=MAX(min.val[1],miny);
max.val[2]=MIN(max.val[2],maxz);
min.val[2]=MAX(min.val[2],minz);
for(xl=(int)floor(min.val[0])-1;xl<ceil(max.val[0])+1;xl++)
   {
   for(yl=(int)floor(min.val[1])-1;yl<ceil(max.val[1])+1;yl++)
      {
      for(zl=(int)floor(min.val[2])-1;zl<=ceil(max.val[2])+1;zl++)
         {
         dist=line_seg_point_dist_3d(c1[2].val[0],c1[2].val[1],c1[2].val[2],c1[3].val[0],c1[3].val[1],c1[3].val[2],
                                                 xl, yl, zl);
         colin=points_colin_3d(c1[2].val[0],c1[2].val[1],c1[2].val[2],xl,yl,zl,c1[3].val[0],c1[3].val[1],c1[3].val[2]);
         if (colin<0.001&&dist<0.1)
            {
            c2[count].val[0]=xl;
            c2[count].val[1]=yl;
            c2[count].val[2]=zl;
            c2[count].val[3]=dist;
            StrCoords(c2[count],xl,yl,zl,'/',1);
            if (line_seg_point_dist_3d(c1[2].val[0],c1[2].val[1],c1[2].val[2],c1[2].val[0],c1[2].val[1],c1[2].val[2],
                xl,yl,zl)<line_seg_point_dist_3d(c1[3].val[0],c1[3].val[1],c1[3].val[2],c1[3].val[0],c1[3].val[1],c1[3].val[2],
                xl,yl,zl))
                c2[count].r1=1;
            else if (line_seg_point_dist_3d(c1[2].val[0],c1[2].val[1],c1[2].val[2],c1[2].val[0],c1[2].val[1],c1[2].val[2],
                xl,yl,zl)>line_seg_point_dist_3d(c1[3].val[0],c1[3].val[1],c1[3].val[2],c1[3].val[0],c1[3].val[1],c1[3].val[2],
                xl,yl,zl))
                c2[count].r1=-1;
            else
                c2[count].r1=0;
            ++count;
            }
         }
      }
   }
return count;
}

void VC::DistVectSort(int sr)
{
float dbArray[1000], dbTemp;
int idx1,idx2,temp;
for(idx1=0;idx1<sr;idxArray[idx1++]=idx1);
for(idx1=0;idx1<sr;dbArray[idx1]=c2[idx1++].val[3]);
for(idx1=0;idx1<sr;idx1++)
   {
   for(idx2=0;idx2<sr;idx2++)
      {
      if(idx1=idx2)
         continue;
      if(dbArray[idx1]<dbArray[idx2])
         {
         temp=idxArray[idx1];
         idxArray[idx1]=idxArray[idx2];
         idxArray[idx2]=temp;
         dbTemp=dbArray[idx1];
         dbArray[idx1]=dbArray[idx2];
         dbArray[idx2]=dbTemp;
         }
      }
   }
depCount=0;
destCount=0;
for(idx1=0;idx1<sr;idx1++)
   {
   if(c2[idx1].r1==-1)
      idxArray1[depCount++]=idxArray[idx1];
   else if(c2[idx1].r1==1)
      idxArray2[destCount++]=idxArray[idx1];
   }
printf("Colinearity search returned %d results within 0.999 linearity and 0.1 sectors\n", sr);
sprintf(tempBuff,"Colinearity search returned %d results within 0.999 linearity and 0.1 sectors</br>\n</font>\n<font color=\"22ff77\">\n", sr);
strcat(resultsBuff,tempBuff);
printf("Possible departure points:\n");
strcat(resultsBuff,"Possible departure points:</br>\n");
for(idx1=0;idx1<sr;idx1++)
    {
    if(c2[idxArray[idx1]].r1==-1)
       {
       printf("Vector passes %lf sectors from point %s\n",c2[idxArray[idx1]].val[3],c2[idxArray[idx1]].xyz);
       sprintf(tempBuff,"%s--->",c2[idxArray[idx1]].xyz);
       strcat(resultsBuff,tempBuff);
       sprintf(tempBuff,"<TD><A title=\"Center comm list on %s\" href=\"http://www.spacetrace.org/com.php?",c2[idxArray[idx1]].xyz);
       strcat(resultsBuff,tempBuff);
       sprintf(tempBuff,"center_x=%d&center_y=%d&center_z=%d&",c2[idxArray[idx1]].xi,c2[idxArray[idx1]].yi,c2[idxArray[idx1]].zi);
       strcat(resultsBuff,tempBuff);
       strcat(resultsBuff,"maxdist=20000&calc\" target=f1><B class=norm><font color=\"22ff77\"><B>Center in comm list</B></B></A></TD>--->\n");
       sprintf(tempBuff,"<TD><A title=\"Center planet list on %s\" href=\"http://www.spacetrace.org/com_planets.php?",c2[idxArray[idx1]].xyz);
       strcat(resultsBuff,tempBuff);
       sprintf(tempBuff,"center_x=%d&center_y=%d&center_z=%d&",c2[idxArray[idx1]].xi,c2[idxArray[idx1]].yi,c2[idxArray[idx1]].zi);
       strcat(resultsBuff,tempBuff);
       strcat(resultsBuff,"maxdist=20000&calc\" target=f2><B class=norm><font color=\"22ff77\"><B>Center in planet list</BR></B></B></A></TD>\n");
       }
    }
printf("Possible destination points:\n");
strcat(resultsBuff,"</font>\n<font color=\"ff2222\">\nPossible destination points:</br>\n");
for (idx1=0;idx1<sr;idx1++)
    {
    if (c2[idxArray[idx1]].r1==1)
       {
       printf("Vector passes %lf sectors from point %s\n",c2[idxArray[idx1]].val[3],c2[idxArray[idx1]].xyz);
       sprintf(tempBuff,"%s--->",c2[idxArray[idx1]].xyz);
       strcat(resultsBuff,tempBuff);
       sprintf(tempBuff,"<TD><A title=\"Center comm list on %s\" href=\"http://www.spacetrace.org/com.php?",c2[idxArray[idx1]].xyz);
       strcat(resultsBuff,tempBuff);
       sprintf(tempBuff,"center_x=%d&center_y=%d&center_z=%d&",c2[idxArray[idx1]].xi,c2[idxArray[idx1]].yi,c2[idxArray[idx1]].zi);
       strcat(resultsBuff,tempBuff);
       strcat(resultsBuff,"maxdist=20000&calc\" target=f1><B class=norm><font color=\"ff2222\"><B>Center in comm list</B></B></A></TD>--->\n");
       sprintf(tempBuff,"<TD><A title=\"Center planet list on %s\" href=\"http://www.spacetrace.org/com_planets.php?",c2[idxArray[idx1]].xyz);
       strcat(resultsBuff,tempBuff);
       sprintf(tempBuff,"center_x=%d&center_y=%d&center_z=%d&",c2[idxArray[idx1]].xi,c2[idxArray[idx1]].yi,c2[idxArray[idx1]].zi);
       strcat(resultsBuff,tempBuff);
       strcat(resultsBuff,"maxdist=20000&calc\" target=f2><B class=norm><font color=\"ff2222\"><B>Center in planet list</BR></B></B></A></TD>\n");
       }
    }
free(tempBuff);
return;
}

int VC::VectorCalc(char *dspr[])
{
int sr,idx,vectCount;
Init();
strcpy(c1[0].xyz,dspr[0]);
strcpy(c1[1].xyz,dspr[1]);
EnumCoords(c1[0],&x,&y,&z);
EnumCoords(c1[1],&x1,&y1,&z1);
printf("Current fleet coordinates:%s\nVector Delta's %s\n",c1[0].xyz,c1[1].xyz);
sprintf(tempBuff,"Current fleet coordinates:%s</br>\nVector Delta's %s</br>\n",c1[0].xyz,c1[1].xyz);
strcat(resultsBuff,tempBuff);
if(!ValidateInput())
   {
   WriteHTML();
   return 0;
   }
ST_Euclidian(&x1,&y1,&z1);
StrCoords(c1[1],x1,y1,z1,';',0);
printf("normalized to:%s\n",c1[1].xyz);
sprintf(tempBuff,"normalized to:%s</br>\n",c1[1].xyz);
strcat (resultsBuff,tempBuff);
ExtrapolatePoints(c1[0], c1[1], c1[2], c1[3]);
SortMinMax();
sr = ColinearitySearch();
DistVectSort(sr);
WriteHTML();
return 0;
}

void VC::WriteHTML()
{
fileBuff=(char*)malloc(1024*64);
sprintf(fileBuff,"%s","<html>\n<title>VECTOR CALCULATION RESULTS</title><body bgcolor=\"444444\">\n<a class=\"norm\">\n<font color=\"2277ff\">\n");
strcat(fileBuff,resultsBuff);
strcat(fileBuff,"</font>\n</a>\n</body>\n</html>");
dataFile=fopen("c:\\spacetrace\\vcresults.htm","wt+");
fwrite(fileBuff,strlen(fileBuff),1,dataFile);
fclose(dataFile);
}

int main(int c, char *argv[])
{
VC *VectorCalculator;
char *dspr[2];
int exitCode;
dspr[0]=(char *)malloc(strlen(argv[1]));
dspr[1]=(char *)malloc(strlen(argv[2]));
strcpy(dspr[0],argv[1]);
strcpy(dspr[1],argv[2]);
VectorCalculator = new VC;
clrscr();
exitCode=VectorCalculator->VectorCalc(dspr);
delete VectorCalculator;
free(dspr[0]);
free(dspr[1]);
delay(1000);
atexit(ExecOnExit);
exit(0);
}

void StrCoords(point &c,double x,double y,double z,char s,char iformat)
{
if(iformat)
   {
   c.xi=(int)x;
   c.yi=(int)y;
   c.zi=(int)z;
   sprintf(c.xyz,"%d%c%d%c%d",c.xi,s,c.yi,s,c.zi);
   }
else
   sprintf(c.xyz,"%lf%c%lf%c%lf",x,s,y,s,z);
c.val[0]=x;
c.val[1]=y;
c.val[2]=z;
return;
}

void EnumCoords(point &coords,double *x,double *y,double *z)
{
char *end_ptr;
*x=strtod(coords.xyz,&end_ptr);
coords.val[0]=*x;
*y=strtod(end_ptr+1,&end_ptr);
coords.val[1]=*y;
*z=strtod(end_ptr+1,&end_ptr);
coords.val[2]=*z;
return;
}

void Euclidian_ST(double *x,double *y,double *z)
{
*x*=15;
*y*=15;
*z*=15;
return;
}

void ST_Euclidian(double *x,double *y,double *z)
{
int temp;
*x/=15;
temp=(int)(*x*1000);
*x=(double)(temp/1000.0);
*y/=15;
temp=(int)(*y*1000);
*y=(double)(temp/1000.0);;
*z/=15;
temp=(int)(*z*1000);
*z=(double)(temp/1000.0);
return;
}

void ExtrapolatePoints(point &c0,point &c1,point &c2,point &c3)
{
//Change each coordinate ->  + (euclidean norm * 100 for forward point)
c2.val[0]=c0.val[0]+(c1.val[0]*100);
c2.val[1]=c0.val[1]+(c1.val[1]*100);
c2.val[2]=c0.val[2]+(c1.val[2]*100);
//and each coordinate -> - (euclidean norm * 100 for reverse point)
c3.val[0]=c0.val[0]-(c1.val[0]*100);
c3.val[1]=c0.val[1]-(c1.val[1]*100);
c3.val[2]=c0.val[2]-(c1.val[2]*100);
return;
}

double RoundToDecimal(double dp, int d)
{
dp*=pow(10,d);
if(dp>0)
   {
   if(dp-floor(dp)>=0.5)
      dp=ceil(dp);
   else
      dp=floor(dp);
   }
else if(dp<0)
   {
   if(dp-ceil(dp)>=0.5)
      dp=floor(dp);
   else
      dp=ceil(dp);
   }
   dp/=pow(10,d);
return dp;
}

void ExecOnExit()
{
system("c:\\iexplore.exe c:\\spacetrace\\vcresults.htm");
return;
}

